package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.XMMapper;
import com.sa.ibiz.demo.demo.domain.XM;
import com.sa.ibiz.demo.demo.service.XMService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.XMSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.OrgSectorService;
import com.sa.ibiz.demo.demo.service.OrgUserService;
import com.sa.ibiz.demo.demo.service.OrgUserService;

/**
 * 实体[XM] 服务对象接口实现
 */
@Service
public class XMServiceImpl extends ServiceImplBase<XMMapper, XM> implements XMService{

    @Autowired
    private OrgSectorService fzbmService;
    @Autowired
    private OrgUserService fzrService;
    @Autowired
    private OrgUserService zxrService;

    @Resource
    private XMMapper xmMapper;


    @Override
    public boolean create(XM et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(XM et){
        this.beforeUpdate(et);
		this.xmMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(XM et){
		return et.getXmid();  
    }

    @Override
    public boolean getDraft(XM et)  {
    if((!StringUtils.isEmpty(et.getFzbmid())) && et.getFzbm() == null){
            try {
                et.setFzbm(fzbmService.getById(et.getFzbmid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getFzrid())) && et.getFzr() == null){
            try {
                et.setFzr(fzrService.getById(et.getFzrid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getZxrid())) && et.getZxr() == null){
            try {
                et.setZxr(zxrService.getById(et.getZxrid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<XM> listDefault(XMSearchFilter filter) {
		return xmMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<XM> searchDefault(XMSearchFilter filter) {
		return xmMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return xmMapper.selectRow(sql);
    }

 }